#ifndef __ASVARIANT_H_
#define __ASVARIANT_H_

#ifndef APPNAME
#define APPNAME "sqflash"
#endif

#define APPNAMESPACE "cmodule." APPNAME "."

typedef struct _AS3_Val *AS3_Val;

/**
 * AS3i[łoAg
 * ̃LbV/js
 */
class AS3Variant {

public:
	/**
	 * RXgN^
	 */
	AS3Variant();

	AS3Variant(bool n);
	
	AS3Variant(int n);

	AS3Variant(float n);

	AS3Variant(double n);

	AS3Variant(const char *str);

	AS3Variant(AS3_Val val);

	AS3Variant(const AS3Variant &orig);

	/**
	 * ej undefined ɂ
	 */
	void clear();

	/**
	 * fXgN^
	 */
	~AS3Variant();

	// 
	AS3Variant &operator=(const AS3Variant &orig);

	// r
	bool operator==(const AS3Variant &target);

	operator int() const;
	
	operator double() const;
	
	operator float() const;
	
	operator const char*();

	operator char*();
	
	/**
	 * ByteArray ̃oCgǂݏo
	 * @param buffer i[obt@
	 * @param size i[TCY
	 */
	void readBytes(char *buffer, int size);

	// g[X\
	void trace();

	// -------------------------------------------------------
	// ^
	// -------------------------------------------------------

	// ^
	enum Type {
		TYPE_UNDEFINED, ///< `
		TYPE_NULL,      ///< null
		TYPE_BOOLEAN,   ///< ^Ul
		TYPE_FUNCTION,  ///< ֐
		TYPE_INTEGER,   ///<  (int or uint)
		TYPE_NUMBER,    ///< l
		TYPE_OBJECT,    ///< IuWFNg
		TYPE_STRING,    ///< 
		TYPE_XML,       ///< XML
		TYPE_UNKNOWN,   ///< s
	};

	/**
	 * @return ^
	 */
	Type getType() const;

	/**
	 * @return `Ȃ true
	 */
	bool isUndefined() const;

	/**
	 *@return NXIuWFNgȂ true
	 */
	bool isClass() const;

	/**
	 *@return t@NVȂ true
	 */
	bool isFunction() const;
	
	/**
	 * @reutrn IuWFNgȂ true
	 */
	bool isObject() const;
	
	/**
	 * AS3NX擾
	 * @param instance CX^X
	 * @return NX
	 */
	AS3Variant getClassName() const;

	// -------------------------------------------------------
	// setter/getter
	// -------------------------------------------------------

	/**
	 * l擾
	 * @param obj ΏƃIuWFNg
	 * @param o
	 * @return o̒lintŕԂ
	 */
	AS3Variant get(const AS3Variant &name) const;

	template <typename T>
	AS3Variant get(const T name) const {
		return get(AS3Variant(name));
	}
	
	/**
	 * lݒ
	 * @param obj ΏƃIuWFNg
	 * @param o
	 * @param value ݒl
	 */
	void set(const AS3Variant &name, const AS3Variant &value);

	template <typename T>
	void set(const T name, const AS3Variant &value) {
		set(AS3Variant(name), value);
	}
	
	/**
	 * zƂ݂Ȃăp[^ǉ
	 */
	void arrayPush(const AS3Variant &value);

	template <typename T>
	void arrayPush(T &n) {
		arrayPush(AS3Variant(n));
	}

	// --------------------------------------------------------------

	/**
	 * t@NVĂяo
	 * @param args Xg
	 * @return Al
	 */
	AS3Variant call(AS3Variant *args=0);

	template<typename T1>
	AS3Variant call(const T1 &t1) {
		AS3Variant arg = createArray(t1);
		return call(&arg);
	}

	template<typename T1, typename T2>
	AS3Variant call(const T1 &t1, const T2 &t2) {
		AS3Variant arg = createArray(t1, t2);
		return call(&arg);
	}

	template<typename T1, typename T2, typename T3>
	AS3Variant call(const T1 &t1, const T2 &t2, const T3 &t3) {
		AS3Variant arg = createArray(t1, t2, t3);
		return call(&arg);
	}

	/**
	 * \bhĂяo(\bhw)
	 * @param methodName \bh
	 * @param args 
	 */
	AS3Variant callMethod(const char *methodName, AS3Variant *args=0);

	template<typename T1>
	AS3Variant callMethod(const char *methodName, const T1 &t1) {
		AS3Variant arg = createArray(t1);
		return callMethod(methodName, &arg);
	}

	template<typename T1, typename T2>
	AS3Variant callMethod(const char *methodName, const T1 &t1, const T2 &t2) {
		AS3Variant arg = createArray(t1, t2);
		return callMethod(methodName, &arg);
	}

	template<typename T1, typename T2, typename T3>
	AS3Variant callMethod(const char *methodName, const T1 &t1, const T2 &t2, const T3 &t3) {
		AS3Variant arg = createArray(t1, t2, t3);
		return callMethod(methodName, &arg);
	}
	
	/**
	 * \bhĂяo(\bhڎw)
	 * @param method \bhIuWFNg
	 * @param args 
	 */
	AS3Variant callMethod(const AS3Variant &method, AS3Variant *args=0);

	template<typename F, typename T1>
	AS3Variant callMethod(const F &method, const T1 &t1) {
		AS3Variant arg = createArray(t1);
		return callMethod(method, &arg);
	}

	template<typename F, typename T1, typename T2>
	AS3Variant callMethod(const F &method, const T1 &t1, const T2 &t2) {
		AS3Variant arg = createArray(t1, t2);
		return callMethod(method, &arg);
	}

	template<typename F, typename T1, typename T2, typename T3>
	AS3Variant callMethod(const F &method, const T1 &t1, const T2 &t2, const T3 &t3) {
		AS3Variant arg = createArray(t1, t2, t3);
		return callMethod(method, &arg);
	}

	/**
	 * NX̃CX^X
	 * @param args 
	 * @return ꂽCX^X
	 */
	AS3Variant createInstance(AS3Variant *args=0);

	template<typename T>
	AS3Variant createInstance(const T &t1) {
		AS3Variant arg = createArray(t1);
		return createInstance(&arg);
	}

	template<typename T1, typename T2>
	AS3Variant createInstance(const T1 &t1, const T2 &t2) {
		AS3Variant arg = createArray(t1,t2);
		return createInstance(&arg);
	}
	
	template<typename T1, typename T2, typename T3>
	AS3Variant createInstance(const T1 &t1, const T2 &t2, const T3 &t3) {
		AS3Variant arg = createArray(t1,t2,t3);
		return createInstance(&arg);
	}

	// -------------------------------------------------------
	// ꏉ
	// -------------------------------------------------------

	/**
	 * O[o֐ŏ
	 */
	static AS3Variant createFunction(const char *funcName);

	/**
	 * AS3NX
	 * @param className NX
	 */
	template<typename T>
	static AS3Variant createClass(T className) {
		AS3Variant func = createFunction("flash.utils.getDefinitionByName");
		return func.call(className);
	}
	
	/**
	 * AS3
	 * @param className NX
	 */
	static AS3Variant createDictionary();

	/**
	 * AS3z񐶐
	 * @param className NX
	 */
	static AS3Variant createArray();
	
	template<typename T1>
	static AS3Variant createArray(const T1 &t1) {
		AS3Variant ret = createArray();
		ret.arrayPush(t1);
		return ret;
	}

	template<typename T1, typename T2>
	static AS3Variant createArray(const T1 &t1, const T2 &t2) {
		AS3Variant ret = createArray();
		ret.arrayPush(t1);
		ret.arrayPush(t2);
		return ret;
	}

	template<typename T1, typename T2, typename T3>
	static AS3Variant createArray(const T1 &t1, const T2 &t2, const T3 &t3) {
		AS3Variant ret = createArray();
		ret.arrayPush(t1);
		ret.arrayPush(t2);
		ret.arrayPush(t3);
		return ret;
	}

	AS3_Val getObj();
	
private:
	AS3_Val obj;
	char *str;
};

#endif